--- libgomp/omp_lib.f90.in.jj	2013-04-10 12:34:26.000000000 +0200
+++ libgomp/omp_lib.f90.in	2013-06-12 14:13:46.094429932 +0200
@@ -129,21 +129,18 @@
 
         interface
           function omp_get_dynamic ()
-            use omp_lib_kinds
             logical (4) :: omp_get_dynamic
           end function omp_get_dynamic
         end interface
 
         interface
           function omp_get_nested ()
-            use omp_lib_kinds
             logical (4) :: omp_get_nested
           end function omp_get_nested
         end interface
 
         interface
           function omp_in_parallel ()
-            use omp_lib_kinds
             logical (4) :: omp_in_parallel
           end function omp_in_parallel
         end interface
@@ -158,28 +155,24 @@
 
         interface
           function omp_get_max_threads ()
-            use omp_lib_kinds
             integer (4) :: omp_get_max_threads
           end function omp_get_max_threads
         end interface
 
         interface
           function omp_get_num_procs ()
-            use omp_lib_kinds
             integer (4) :: omp_get_num_procs
           end function omp_get_num_procs
         end interface
 
         interface
           function omp_get_num_threads ()
-            use omp_lib_kinds
             integer (4) :: omp_get_num_threads
           end function omp_get_num_threads
         end interface
 
         interface
           function omp_get_thread_num ()
-            use omp_lib_kinds
             integer (4) :: omp_get_thread_num
           end function omp_get_thread_num
         end interface
@@ -232,44 +225,37 @@
 
         interface
           function omp_get_thread_limit ()
-            use omp_lib_kinds
             integer (4) :: omp_get_thread_limit
           end function omp_get_thread_limit
         end interface
 
         interface omp_set_max_active_levels
           subroutine omp_set_max_active_levels (max_levels)
-            use omp_lib_kinds
             integer (4), intent (in) :: max_levels
           end subroutine omp_set_max_active_levels
           subroutine omp_set_max_active_levels_8 (max_levels)
-            use omp_lib_kinds
             integer (8), intent (in) :: max_levels
           end subroutine omp_set_max_active_levels_8
         end interface
 
         interface
           function omp_get_max_active_levels ()
-            use omp_lib_kinds
             integer (4) :: omp_get_max_active_levels
           end function omp_get_max_active_levels
         end interface
 
         interface
           function omp_get_level ()
-            use omp_lib_kinds
             integer (4) :: omp_get_level
           end function omp_get_level
         end interface
 
         interface omp_get_ancestor_thread_num
           function omp_get_ancestor_thread_num (level)
-            use omp_lib_kinds
             integer (4), intent (in) :: level
             integer (4) :: omp_get_ancestor_thread_num
           end function omp_get_ancestor_thread_num
           function omp_get_ancestor_thread_num_8 (level)
-            use omp_lib_kinds
             integer (8), intent (in) :: level
             integer (4) :: omp_get_ancestor_thread_num_8
           end function omp_get_ancestor_thread_num_8
@@ -277,12 +263,10 @@
 
         interface omp_get_team_size
           function omp_get_team_size (level)
-            use omp_lib_kinds
             integer (4), intent (in) :: level
             integer (4) :: omp_get_team_size
           end function omp_get_team_size
           function omp_get_team_size_8 (level)
-            use omp_lib_kinds
             integer (8), intent (in) :: level
             integer (4) :: omp_get_team_size_8
           end function omp_get_team_size_8
@@ -290,21 +274,18 @@
 
         interface
           function omp_get_active_level ()
-            use omp_lib_kinds
             integer (4) :: omp_get_active_level
           end function omp_get_active_level
         end interface
 
         interface
           function omp_in_final ()
-            use omp_lib_kinds
             logical (4) :: omp_in_final
           end function omp_in_final
         end interface
 
         interface
           function omp_get_cancellation ()
-            use omp_lib_kinds
             logical (4) :: omp_get_cancellation
           end function omp_get_cancellation
         end interface
@@ -327,28 +308,24 @@
 
         interface
           function omp_get_default_device ()
-            use omp_lib_kinds
             integer (4) :: omp_get_default_device
           end function omp_get_default_device
         end interface
 
         interface
           function omp_get_num_devices ()
-            use omp_lib_kinds
             integer (4) :: omp_get_num_devices
           end function omp_get_num_devices
         end interface
 
         interface
           function omp_get_num_teams ()
-            use omp_lib_kinds
             integer (4) :: omp_get_num_teams
           end function omp_get_num_teams
         end interface
 
         interface
           function omp_get_team_num ()
-            use omp_lib_kinds
             integer (4) :: omp_get_team_num
           end function omp_get_team_num
         end interface